local slots = {
	-- inspect those
	BackSlot = true,
	ChestSlot = true,
	FeetSlot = true,
	Finger0Slot = true,
	Finger1Slot = true,
	HandsSlot = true,
	HeadSlot = true,
	LegsSlot = true,
	MainHandSlot = true,
	NeckSlot = true,
	RangedSlot = true,
	SecondaryHandSlot = true,
	ShoulderSlot = true,
	Trinket0Slot = true,
	Trinket1Slot = true,
	WaistSlot = true,
	WristSlot = true,
	-- do not inspect those slots, still keep them in file in case they need changing
	AmmoSlot = false,
	Bag0Slot = false,
	Bag1Slot = false,
	Bag2Slot = false,
	Bag3Slot = false,
	Bag4Slot = false,
	ShirtSlot = false,
	TabardSlot = false,
}
--table of all enchantIDs containing abyss crystal, in enchantID = spellID format
local forbidden_enchants = {
	[3827] = 60691, -- 2h weapon - massacre
	[3850] = 62256, -- bracers - 40 stamina
	[3832] = 60692, -- chest - 10 stats
	[3256] = 44631, -- cloak - shadow armor [10 agi and stealth]
	[3296] = 47899, -- cloak - wisdom [10 spirit and -2% threat]
	[3854] = 62948, -- staff - 81 spellpower
	[3788] = 59619, -- weapon - accuracy [25 crit rating and 25 hit rating]
	[3789] = 59621, -- weapon - berserking
	[3790] = 59625, -- weapon - black magic
	[3869] = 64441, -- weapon - blade ward
	[3870] = 64579, -- weapon - blood draining
	[3834] = 60714, -- weapon - mighty spellpower
	[3833] = 60707, -- weapon - superior potency
	[3852] = 62384, -- greater inscription of the gladiator
	[3810] = 59937, -- greater inscription of the storm
	[3811] = 59941, -- greater inscription of the pinnacle
	[3809] = 59936, -- greater inscription of the crag
	[3808] = 59934, -- greater inscription of the axe
}
--allowed epic items
local allowed_epics = {
	--Engineering heads
	[42549] = true, -- Armored Titanium Goggles
	[42552] = true, -- Charged Titanium Specs
	[42555] = true, -- Electroflux Sight Enhancers
	[42554] = true, -- Greensight Gogs
	[42551] = true, -- Truesight Ice Blinders
	[44949] = true, -- Unbreakable Healing Amplifiers
	[42553] = true, -- Visage Liquification Goggles
	[42550] = true, -- Weakness Spectralizers
}
local nslots
local jcgem
local a = CreateFrame("Frame")
a:SetScript("OnEvent", function(isEvent)
	local realnumraid, numraid = GetRealNumRaidMembers(), GetNumRaidMembers()
	--battleground
	if realnumraid ~= numraid then if (not isEvent) then print("|cffffff00Failed!|r You are in a battleground!") end return end
	--get the localized name of the dragon's eye gem
	if not jcgem then
		jcgem = (GetItemInfo(42225))
	end
	--get numeric equip slot ids
	if not nslots then
		nslots = {}
		for slot, show in pairs(slots) do
			if show then
				nslots[(GetInventorySlotInfo(slot))] = true
			end
		end
	end
	local isWarning = false
	--inspect all raid members
	for i=1, realnumraid do
		local u = "raid"..i
		--is in range? is the player inspecting something?
		if CanInspect(u) and (not (InspectFrame and InspectFrame:IsShown())) then
			--get inventory data
			NotifyInspect("raid"..i)
			for slot in pairs(nslots) do
				local link, isEpic, itemID = GetInventoryItemLink(u, slot), (GetInventoryItemQuality(u, slot)>=4), GetInventoryItemID(u, slot)
				-- see if anything is actually there
				if link then
					-- get item level
					local itemLevel = (select(4, GetItemInfo(itemID)))
					--notify for epic items
					if isEpic and (not allowed_epics[itemID]) and (itemLevel >= 200) then
						print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which is of epic or higher quality!")
						isWarning = true
					end
					--loop through all gem slots and check for epic non-JC-only gems
					for numgem=1, 3 do
						local _, gemlink = GetItemGem(link, numgem)
						if gemlink then
							local gemID = tonumber(string.match(gemlink, "|Hitem:(%d+):"))
							local name, _, quality = GetItemInfo(gemID)
							if name then
								if (quality == 4) and not name:find(jcgem) then
									print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which contains an epic "..gemlink.." gem!")
									isWarning = true
								end
							end
						end
					end
					--extract enchantid from itemlink
					local enchantID = tonumber(string.match(link, "|Hitem:"..itemID..":(%d+):"))
					if enchantID and forbidden_enchants[enchantID] then
						local enchantspellID = forbidden_enchants[enchantID]
						print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which has the forbidden enchant |cffffd000|Henchant:"..enchantspellID.."|h["..(GetSpellInfo(enchantspellID)).."]|h|r applied!")
						isWarning = true
					end
				end
			end
			ClearInspectPlayer()
		end
	end
	if realnumraid > 0 then
		if not isWarning then
			print("|cff00ff00Cleared!|r Your raid has no epic gear, enchants or gems!")
		end
	else
		if (not isEvent) then
			print("|cffffff00Failed!|r You are not in a raid group!")
		end
	end
end)
a:RegisterEvent("PLAYER_REGEN_DISABLED")
SlashCmdList["BLUECHECK"] = function()
	a:GetScript("OnEvent")()
end
SLASH_BLUECHECK1 = "/bluecheck"
local function DoInspect(u)
	--is the input a valid unit
	if not UnitExists(u) then return end
	--get the localized name of the dragon's eye gem
	if not jcgem then
		jcgem = (GetItemInfo(42225))
	end
	--get numeric equip slot ids
	if not nslots then
		nslots = {}
		for slot, show in pairs(slots) do
			if show then
				nslots[(GetInventorySlotInfo(slot))] = true
			end
		end
	end
	local isWarning = false
	--is in range? is the player inspecting something?
	if CanInspect(u) and (not (InspectFrame and InspectFrame:IsShown())) then
		--get inventory data
		NotifyInspect("raid"..i)
		for slot in pairs(nslots) do
			local link, isEpic, itemID = GetInventoryItemLink(u, slot), (GetInventoryItemQuality(u, slot)>=4), GetInventoryItemID(u, slot)
			if link then
				--get item level
				local itemLevel = (select(4, GetItemInfo(itemID)))
				--notify for epic items
				if isEpic and (not allowed_epics[itemID]) and (itemLevel >= 200) then
					print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which is of epic or higher quality!")
					isWarning = true
				end
				--loop through all gem slots and check for epic non-JC-only gems
				for numgem=1, 3 do
					local _, gemlink = GetItemGem(link, numgem)
					if gemlink then
						local gemID = tonumber(string.match(gemlink, "|Hitem:(%d+):"))
						local name, _, quality = GetItemInfo(gemID)
						if name then
							if (quality == 4) and not name:find(jcgem) then
								print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which contains an epic "..gemlink.." gem!")
								isWarning = true
							end
						end
					end
				end
				--extract enchantid from itemlink
				local enchantID = tonumber(string.match(link, "|Hitem:"..itemID..":(%d+):"))
				if enchantID and forbidden_enchants[enchantID] then
					local enchantspellID = forbidden_enchants[enchantID]
					print("|cffff0000Warning!|r "..(UnitName(u)).." is wearing the item "..link..", which has the forbidden enchant |cffffd000|Henchant:"..enchantspellID.."|h["..(GetSpellInfo(enchantspellID)).."]|h|r applied!")
					isWarning = true
				end
			end
		end
		ClearInspectPlayer()
		if not isWarning then
			print("|cff00ff00Cleared!|r "..(UnitName(u)).." has no epic gear, enchants, or gems!")
		end
	else
		print("|cffffff00Failed!|r Player is not in inspect range or you are already inspecting somebody!")
	end
end
SlashCmdList["CHECKPLAYER"] = DoInspect
SLASH_CHECKPLAYER1 = "/checkplayer"